package go_swagger

import (
	"github.com/juju/errors"

	"git.dev.m-and-m.ovh/mderasse/gouick/helpers"
	"git.dev.m-and-m.ovh/mderasse/gouick/models"

	log "github.com/sirupsen/logrus"
)

// GenerateAPI will generate api files such as server, controllers, test, ....
func (a APIType) GenerateAPI(path string, config *models.Config) error {
	log.Debugf("Starting %s - %s", a.GetName(), helpers.GetCurrentFuncName())

	// Launch Go Swagger
	err := a.executeGoSwagger(path)
	if err != nil {
		log.Error("Fail to Execute Go Swagger")
		return errors.Trace(err)
	}

	// Delete api yaml temporary file
	err = a.deleteTempApiYaml(path)
	if err != nil {
		log.Error("Fail to delete api yaml temporary file")
		return errors.Trace(err)
	}

	return nil
}
